<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/ascat.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>ascat.c</h1><a href="ascat_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: ascat.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">/* Scatters and gathers integer data */</span>
<a name="l00030"></a><a class="code" href="util_8h.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">00030</a> <span class="keywordtype">int</span> <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(<span class="keywordtype">int</span> **aindata,<span class="keywordtype">int</span> n_items,<span class="keywordtype">int</span> s_item,<span class="keywordtype">int</span> *newproc,<span class="keywordtype">int</span> insize,<span class="keywordtype">int</span> send)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordtype">int</span> rank,size;
<a name="l00035"></a>00035   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00036"></a>00036   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   assert(insize&gt;=1);
<a name="l00039"></a>00039   <span class="comment">/* this function only works for distributing data from first processor</span>
<a name="l00040"></a>00040 <span class="comment">     to other processors</span>
<a name="l00041"></a>00041 <span class="comment">     TODO: round robin below does not work anyway; thus, simplify this function!</span>
<a name="l00042"></a>00042 <span class="comment">  */</span>
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (!rank) {
<a name="l00044"></a>00044     assert(n_items&gt;0);
<a name="l00045"></a>00045   }
<a name="l00046"></a>00046   <span class="keywordflow">else</span> {
<a name="l00047"></a>00047     assert(n_items==0);
<a name="l00048"></a>00048   }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordtype">int</span>     *ta_n_items;          <span class="comment">/* number of items */</span>
<a name="l00051"></a>00051   ierr = PetscMalloc(insize*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;ta_n_items);CHKERRQ(ierr);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordtype">int</span>     *ta_cnt;              <span class="comment">/* counter for items */</span>
<a name="l00054"></a>00054   ierr = PetscMalloc(insize*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;ta_cnt);CHKERRQ(ierr);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keywordtype">int</span>     *ta_getn_items;       <span class="comment">/* number of items to be received */</span>
<a name="l00057"></a>00057   ierr = PetscMalloc(insize*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;ta_getn_items);CHKERRQ(ierr);
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="keywordtype">int</span>     **ta_procdata;       <span class="comment">/* pointer into data arrays */</span>
<a name="l00060"></a>00060   ierr = PetscMalloc(insize*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>*),&amp;ta_procdata);CHKERRQ(ierr);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordtype">int</span>     *indata;
<a name="l00063"></a>00063   indata=*aindata;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">/* allocate memory for temporary array of sorted data;</span>
<a name="l00066"></a>00066 <span class="comment">     at least one item to avoid malloc&#39;s complaints about allocating zero bytes</span>
<a name="l00067"></a>00067 <span class="comment">  */</span>
<a name="l00068"></a>00068   <span class="keywordtype">int</span> *t_data;
<a name="l00069"></a>00069   ierr = PetscMalloc(n_items*s_item*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)+1,&amp;t_data);CHKERRQ(ierr);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">/* reset counters */</span>
<a name="l00072"></a>00072   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;insize; i++)
<a name="l00073"></a>00073   {
<a name="l00074"></a>00074     ta_n_items[i]=0;
<a name="l00075"></a>00075     ta_cnt[i]=0;
<a name="l00076"></a>00076   }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">/* count number of items to be sent */</span>
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n_items; i++)
<a name="l00080"></a>00080   {
<a name="l00081"></a>00081     assert(newproc[i]&gt;=0 &amp;&amp; newproc[i]&lt;insize);
<a name="l00082"></a>00082     ta_n_items[newproc[i]]++;
<a name="l00083"></a>00083   }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">/* set pointers to start of data in temporary array */</span>
<a name="l00086"></a>00086   ta_procdata[0]=t_data;
<a name="l00087"></a>00087   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1; i&lt;insize; i++)
<a name="l00088"></a>00088   {
<a name="l00089"></a>00089     ta_procdata[i] = ta_procdata[i-1] + s_item*ta_n_items[i-1];
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">/* check pointers for consistency */</span>
<a name="l00093"></a>00093   assert(ta_procdata[insize-1]+s_item*ta_n_items[insize-1]==t_data+n_items*s_item);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">/* copy data sorted into temporary array */</span>
<a name="l00097"></a>00097   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n_items; i++)
<a name="l00098"></a>00098   {
<a name="l00099"></a>00099     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;s_item; j++)
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101       *(ta_procdata[newproc[i]]+ta_cnt[newproc[i]]*s_item+j)=indata[i*s_item+j];
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103     ta_cnt[newproc[i]]++;
<a name="l00104"></a>00104   }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (!send) {
<a name="l00107"></a>00107     ierr = PetscFree(*aindata);CHKERRQ(ierr);
<a name="l00108"></a>00108     *aindata=t_data;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     ierr = PetscFree(ta_procdata);CHKERRQ(ierr);
<a name="l00111"></a>00111     ierr = PetscFree(ta_n_items);CHKERRQ(ierr);
<a name="l00112"></a>00112     ierr = PetscFree(ta_cnt);CHKERRQ(ierr);
<a name="l00113"></a>00113     ierr = PetscFree(ta_getn_items);CHKERRQ(ierr);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00116"></a>00116   }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">/* sendrecv the number of items to be sent/received */</span>
<a name="l00119"></a>00119   <span class="keywordtype">int</span> t_gettot=0;
<a name="l00120"></a>00120   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i &lt; insize-1; i++) {
<a name="l00121"></a>00121     <span class="keywordtype">int</span> pto,pfrom;
<a name="l00122"></a>00122     pto   = (rank+i+1+insize) % insize;
<a name="l00123"></a>00123     pfrom = (rank-i-1+insize) % insize;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="preprocessor">#ifndef UNIPROC</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>    MPI_Status status;
<a name="l00127"></a>00127     MPI_Sendrecv(&amp;ta_n_items[pto],1,MPI_INT,pto,0,
<a name="l00128"></a>00128                  &amp;ta_getn_items[pfrom],1,MPI_INT,pfrom,0,PETSC_COMM_WORLD,&amp;status);
<a name="l00129"></a>00129 <span class="preprocessor">#endif</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span>
<a name="l00131"></a>00131     t_gettot += ta_getn_items[pfrom];
<a name="l00132"></a>00132   }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">/* allocate array for final local data */</span>
<a name="l00135"></a>00135   <span class="comment">/* at least one byte to avoid failure of malloc: Cannot malloc size zero! */</span>
<a name="l00136"></a>00136   <span class="comment">/* may happen with bndfacvert, that no data are to be delivered */</span>
<a name="l00137"></a>00137   <span class="keywordtype">int</span> *t_fdata;
<a name="l00138"></a>00138   ierr = PetscMalloc(s_item*(t_gettot+ta_n_items[rank])*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)+1,&amp;t_fdata);CHKERRQ(ierr);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   ta_procdata[rank]=t_fdata;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">/* copy local data from original array into final array */</span>
<a name="l00143"></a>00143   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n_items; i++)
<a name="l00144"></a>00144   {
<a name="l00145"></a>00145     <span class="comment">/* first processor copies its data to beginning of the array */</span>
<a name="l00146"></a>00146     assert(rank==0);
<a name="l00147"></a>00147     <span class="keywordflow">if</span> (newproc[i]==rank) {
<a name="l00148"></a>00148       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;s_item; j++)
<a name="l00149"></a>00149       {
<a name="l00150"></a>00150         *ta_procdata[rank]=indata[i*s_item+j];
<a name="l00151"></a>00151         ta_procdata[rank]++;
<a name="l00152"></a>00152       }
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154   }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="comment">/* check counter for consistency */</span>
<a name="l00157"></a>00157   assert(ta_procdata[rank]-t_fdata==s_item*ta_n_items[rank]);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">/* sendrecv data to/from all(!) processors */</span>
<a name="l00160"></a>00160   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i &lt; insize-1; i++) {
<a name="l00161"></a>00161     <span class="keywordtype">int</span> pto,pfrom;
<a name="l00162"></a>00162     pto   = (rank+i+1+insize) % insize;
<a name="l00163"></a>00163     pfrom = (rank-i-1+insize) % insize;
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#ifndef UNIPROC</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>    MPI_Status status;
<a name="l00167"></a>00167     MPI_Sendrecv(ta_procdata[pto],s_item*ta_n_items[pto],MPI_INT,pto,1,
<a name="l00168"></a>00168                  ta_procdata[rank],s_item*ta_getn_items[pfrom],MPI_INT,pfrom,1,PETSC_COMM_WORLD,&amp;status);
<a name="l00169"></a>00169 <span class="preprocessor">#endif</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>
<a name="l00171"></a>00171     ta_procdata[rank] += s_item*ta_getn_items[pfrom];
<a name="l00172"></a>00172   }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">/* check counter for consistency */</span>
<a name="l00175"></a>00175   assert(ta_procdata[rank]-t_fdata==s_item*(t_gettot+ta_n_items[rank]));
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   ierr = PetscFree(t_data);CHKERRQ(ierr);
<a name="l00178"></a>00178   <span class="keywordflow">if</span> (n_items&gt;0) {
<a name="l00179"></a>00179     ierr = PetscFree(*aindata);CHKERRQ(ierr);
<a name="l00180"></a>00180   }
<a name="l00181"></a>00181   *aindata=t_fdata;
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   t_gettot += ta_n_items[rank];
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   ierr = PetscFree(ta_procdata);CHKERRQ(ierr);
<a name="l00186"></a>00186   ierr = PetscFree(ta_n_items);CHKERRQ(ierr);
<a name="l00187"></a>00187   ierr = PetscFree(ta_cnt);CHKERRQ(ierr);
<a name="l00188"></a>00188   ierr = PetscFree(ta_getn_items);CHKERRQ(ierr);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(t_gettot);
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

